let moment = require('moment')

module.exports = {
    friendlyName: "Find",

    description: "Find.",

    inputs: {
        
        codMoy: {
            type: "string",
            require: true
        },
        anneeScolaire: {
            type: "string",
            require: true
        },
    },

    exits: {
        notFound: {
            statusCode: 404
        },
    },

    fn: async function (inputs, exits) {
        const { id, user } = this.req.token;
        //console.log("ID", id, user.login, user.typeUser, user.codeEcole)

        // VERIFICATION DU CODE ECOLE
        if (user.codeEcole === '' || user.codeEcole === null || user.codeEcole === undefined) {
            return exits.notFound({ message: "Veuillez préciser le code Ecole pour cet utulisateur pour a accéder a cette page!" })
        }
        ecoleVerif = await Ecoles.find({ codeEcole: user.codeEcole }).then(_.first)
        if (!ecoleVerif) {
            return exits.notFound({ message: "Cet utilisateur n'est attribué a aucune classe!" })
        }
      
        if (inputs.anneeScolaire === '' || inputs.anneeScolaire === null || inputs.anneeScolaire === undefined) {
            return exits.notFound({ message: "Veuillez préciser une année scolaire pour a accéder a cette page!" })
        }
        console.log("DATE", inputs.startDate, inputs.endDate)
        // CONTROLE SUR USER ET RENVOI DES DATA EN FONCTION DE  USER CONNECTER
        // ACCESSIBLE UNIQUE PAR ADMIN ET ADMINISTRATION

        this.req.query.limit = this.req.query.limit || "100000000";
        this.req.query.skip = this.req.query.skip || "0";

        let userCodeEcole;
        if (user.typeUser === 'ADMINISTRATION') {
            userCodeEcole = user.codeEcole
        } else if (user.typeUser === 'ADMIN') {
            userCodeEcole = undefined
        } else if(user.typeUser === 'ENSEIGNANT') {
            userCodeEcole = user.codeEcole
            inputs.codeEnseignant = user.codeUser
        }
        else {
            return exits.notFound({ message: "Vous n'etes pas autoriser a accéder a cette page!" })

        }


        let fixedAttr = ["codeEcole", "codMoy", "anneeScolaire"];
        let cond = {
            codeEcole: userCodeEcole,
            codMoy: inputs.codMoy,
            anneeScolaire: inputs.anneeScolaire ? inputs.anneeScolaire : undefined,

            //codeEntite: codent,
            /*or: [
                { codeClasse: { contains: inputs.search ? inputs.search.toUpperCase() : "" } },
                { codeMatiere: { contains: inputs.search ? inputs.search.toUpperCase() : "" } },
                // { telephone: { contains: inputs.search ? inputs.search.toUpperCase() : "" } },
            ],*/
        };
        let options = {
            ...this.req.query,
            fixCond: _.pick(cond, fixedAttr),
            sort: "id ASC",
        };

        let notes = await sails.helpers.paginator(ProfNoteDetails, cond, options)
            .then(async (notes) => {
                notes.data = await Promise.all(
                    notes.data.map(async (note) => {
                        let eleve = await Eleves.find({
                            matricule: note.matricule,
                         }).then(_.first);
                         if(eleve){
                            note.eleve = eleve
                            note.matricule= eleve.matricule
                            note.nom = eleve.nom
                            note.sexe =  eleve.sexe
                         }
                        return note
                    })
                );
                return notes
            });

        // All done.
        return exits.success(notes);
    },
};
